/*******************************************************************************
 * FoxGameSearchQuickOnlineGame generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameSearchQuickOnlineGame extends FoxGameSearch within FoxMenuUI
    native(UI)
    config(UI);

var bool bAutoCreateGame;
var bool bAutoReQueueWhenSearchCompletesUnsuccessfully;
var transient bool bLastSearchSuccessful;
var transient bool bCancelledSearching;
var transient bool bShouldInvalidateGameSearchResults;
var bool bOnlineSearchFailed;
var bool bCancelTimerSet;
var bool bJoiningDedicatedServers;
var transient bool bLockCancelProgressText;
var transient bool bFatalSearchErrorOccured;
var transient string DesiredPlaylist;
var transient float TimeSearchStarted;
var transient string URL;
var config float TimeSearchTimeout;
var config int MaxRetriesBeforeGameCreate;
var config int CreateAnywayOdds;
var config string QuickOnslaughtPlaylist;
var int CurrentRetries;
var FoxOnlineStatsWriteMatchmakingReport MatchmakingReport;

function OnlineGameSearch Initialize(int GameSearchIndex)
{
    local class<OnlineGameSearch> GameSearchClass;

    CachedGameSearchIndex = GameSearchIndex;
    CurrentRetries = MaxRetriesBeforeGameCreate;
    GameSearchClass = Outer.Outer.GameSearchDataStore.GetGameSearchClassForIndex(0);
    // End:0xA4
    if(GameSearchClass != none)
    {
        Search = new (self) GameSearchClass;
    }
    // End:0xA6
    else
    {
        return none;
    }
    MatchmakingReport = new class'FoxOnlineStatsWriteMatchmakingReport';
    MatchmakingReport.SetSearchStartTime(Outer.Outer.PCOwner.WorldInfo.RealTimeSeconds);
    return Search;
    //return ReturnValue;    
}

function SetPlaylistParameters(string playlistName, int PlaylistIndex, int PlaylistIndexMax)
{
    // End:0x87
    if(MatchmakingReport != none)
    {
        MatchmakingReport.SetPlaylistName(playlistName);
        MatchmakingReport.SetPlaylistIndex(PlaylistIndex);
        MatchmakingReport.SetPlaylistIndexMax(PlaylistIndexMax);
    }
    //return;    
}

function bool BeginOnlineSearch(optional string playlistName, optional string QueueName)
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local int Index;
    local WorldInfo WI;

    bOnlineSearchFailed = false;
    // End:0x146
    if(NotEqual_InterfaceInterface(Outer.Outer.OnlineSub.PartyInterface, (none)) && Outer.Outer.OnlineSub.PartyInterface.IsPartyTooLarge())
    {
        LaunchPartyMembersOverLimitMessageBox(Outer.Outer.OnlineSub.PartyInterface.GetPartyLimit());
        FailedToSearch();
        return false;
    }
    bShouldInvalidateGameSearchResults = true;
    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    DesiredPlaylist = playlistName;
    Index = -1;
    Outer.Outer.PCOwner.DynamicUI.Menu.ToggleInstantGameModeButtons(false);
    Index = PlaylistDataStore.GetPlaylistIndexFromPlaylistString(DesiredPlaylist);
    Search.SetIntProperty(Outer.Outer.268439552, Index);
    Search.SetStringProperty(Outer.Outer.268435577, DesiredPlaylist);
    // End:0x3B6
    if((Index >= 0) && Index < PlaylistDataStore.PlayListProviders.Length)
    {
        Search.bIsCoopMatchSearch = PlaylistDataStore.PlayListProviders[Index].bCoop;
    }
    Search.SetIntProperty(Outer.Outer.268439570, PlaylistDataStore.GetNumPlaylists());
    // End:0x4AF
    if(DesiredPlaylist != "")
    {
        Search.SetIntProperty(Outer.Outer.268439569, 1 << PlaylistDataStore.GetPlaylistFilterByString(DesiredPlaylist));
    }
    // End:0x51C
    else
    {
        Search.SetIntProperty(Outer.Outer.268439569, PlaylistDataStore.GetPlaylistSearchFilter());
    }
    Search.MatchQueueName = QueueName;
    Search.SetIntProperty(Outer.Outer.268439553, int(FoxPRI(Outer.Outer.PCOwner.PlayerReplicationInfo).Skill));
    Search.SetIntProperty(Outer.Outer.268439568, FoxPRI(Outer.Outer.PCOwner.PlayerReplicationInfo).GetRankIndex());
    LaunchSearchMessageBox();
    WI = class'WorldInfo'.static.GetWorldInfo();
    TimeSearchStarted = WI.RealTimeSeconds;
    bCancelledSearching = false;
    return BeginSearchNow();
    //return ReturnValue;    
}

protected function bool BeginSearchNow()
{
    Outer.Outer.GameInterface.AddFindOnlineGamesCompleteDelegate(OnSearchGamesComplete);
    Outer.Outer.GameInterface.AddCancelFindOnlineGamesCompleteDelegate(OnSearchGamesCancelled);
    Outer.Outer.GameInterface.AddOnSearchProgressUpdatedDelegate(OnSearchProgressUpdated);
    Outer.Outer.GameInterface.AddDedicatedServerSearchCompleteDelegate(OnDedicatedServerSearchComplete);
    Outer.Outer.GameInterface.AddOnOnlinePlatformOOMDelegate(OnOnlinePlatformOOM);
    Outer.Outer.GameInterfaceEx.AddOnLeaveMatchQueueDelegate(OnMatchQueueLeave);
    Outer.Outer.GameInterfaceEx.AddCheckMatchQueueDelegate(OnMatchQueueCheck);
    PendingGameJoinSettings = none;
    MatchmakingReport.IncrementSearchCount();
    // End:0x391
    if(Outer.Outer.GetWorldInfo().IsConsoleBuild(8))
    {
        Search.SetStringProperty(Outer.Outer.268435608, Outer.Outer.GameInterface.GetGameplayRegionName());
    }
    // End:0x43D
    else
    {
        Search.SetStringProperty(Outer.Outer.268435608, Outer.Outer.PCOwner.DynamicUI.GetCurrentRegionTag());
    }
    // End:0x4E9
    if(Outer.Outer.GameSearchDataStore.BeginGameSearch(Search, bShouldInvalidateGameSearchResults))
    {
        Outer.Outer.SetTimer(5.0, CheckMatchQueue);
    }
    // End:0x4F5
    else
    {
        FailedToSearch();
        return false;
    }
    return true;
    //return ReturnValue;    
}

function OnMatchQueueCheck(string QueueName, bool bMatchReady, int PlaceInQueue, string IP, int Port, string Password)
{
    // End:0x17
    if(bMatchReady)
    {
        StopCheckQueue();
    }
    //return;    
}

function OnMatchQueueLeave(string QueueName, bool bSuccess)
{
    StopCheckQueue();
    //return;    
}

function FailedToSearch()
{
    bOnlineSearchFailed = true;
    MatchmakingReport.UpdateResolution(5);
    super.FailedToSearch();
    //return;    
}

function RestartSearchForNativeGames()
{
    bJoiningDedicatedServers = false;
    Outer.Outer.GameInterface.ClearHybridSearchResults();
    // End:0xB9
    if(Outer.Outer.GameSearchDataStore.BeginGameSearch(Search, true) == false)
    {
        FailedToSearch();
    }
    //return;    
}

function OnDedicatedServerSearchComplete(bool bWasSuccessful)
{
    Outer.Outer.GameInterface.ClearDedicatedServerSearchCompleteDelegate(OnDedicatedServerSearchComplete);
    bLastSearchSuccessful = bWasSuccessful;
    // End:0xD3
    if(bCancelledSearching)
    {
        Outer.Outer.GameInterface.ClearHybridSearchResults();
        CloseGameSearch();
        return;
    }
    // End:0xEE
    if(!bWasSuccessful)
    {
        RestartSearchForNativeGames();
        return;
    }
    SetProgressText("matchmakingwidgetsortingresults");
    Outer.Outer.GameSearchDataStore.SortSearchResults(Search, Outer.Outer.PCOwner);
    bJoiningDedicatedServers = true;
    JoinBestGame();
    //return;    
}

function OnSearchGamesComplete(bool bWasSuccessful)
{
    local WorldInfo WI;
    local int Index;
    local float DT;

    WI = class'WorldInfo'.static.GetWorldInfo();
    bLastSearchSuccessful = bWasSuccessful;
    DT = TimeSearchTimeout - (WI.RealTimeSeconds - TimeSearchStarted);
    // End:0xDF
    if(!bWasSuccessful)
    {
        // End:0xDC
        if(!bCancelledSearching)
        {
            SetProgressText("MatchmakingWidgetRetrying", MaxRetriesBeforeGameCreate - CurrentRetries, MaxRetriesBeforeGameCreate);
        }
    }
    // End:0x2C8
    else
    {
        MatchmakingReport.LogFoundRooms(Search.Results.Length);
        Index = 0;
        J0x128:
        // End:0x2C8 [Loop If]
        if(Index < Search.Results.Length)
        {
            // End:0x2BA
            if(Search.Results[Index].GameSettings.PingInMs > 0)
            {
                MatchmakingReport.AddForAverage(Search.Results[Index].GameSettings.PingInMs, Search.Results[Index].GameSettings.NumOpenSlots, Search.Results[Index].GameSettings.MatchQuality);
            }
            ++ Index;
            // [Loop Continue]
            goto J0x128;
        }
    }
    // End:0x323
    if(Outer.Outer.GetWorldInfo().IsConsoleBuild(8))
    {
        RequeableSearchComplete();
        return;
    }
    // End:0x384
    if(DT > float(0))
    {
        Outer.Outer.SetTimer(DT, RequeableSearchComplete);
        return;
    }
    Outer.Outer.SetTimer(0.0, RequeableSearchComplete);
    //return;    
}

function RequeableSearchComplete()
{
    local bool bIsHostingMaterial, bShouldRandomHost;

    Outer.Outer.GameInterface.ClearCancelFindOnlineGamesCompleteDelegate(OnSearchGamesCancelled);
    // End:0x98
    if(Search.bIsSearchInProgress || bCancelledSearching)
    {
        CloseGameSearch();
        return;
    }
    // End:0x170
    if(bLastSearchSuccessful && bAutoJoinGame)
    {
        SetProgressText("matchmakingwidgetsortingresults");
        Outer.Outer.GameSearchDataStore.SortSearchResults(Search, Outer.Outer.PCOwner);
        JoinBestGame();
    }
    // End:0x331
    if(!bLastSearchSuccessful)
    {
        bIsHostingMaterial = Outer.Outer.GameInterface.IsAllowedToNetworkHost();
        MatchmakingReport.SetHostable(bIsHostingMaterial);
        bShouldRandomHost = Rand(CreateAnywayOdds) == 0;
        // End:0x29B
        if((bAutoCreateGame && bIsHostingMaterial) && (bShouldRandomHost || CurrentRetries <= 0) || Search.bDisableRequeuing)
        {
            TryCreateOnlineGame(DesiredPlaylist, "?PublicGame=1");
        }
        // End:0x331
        else
        {
            // End:0x2EC
            if(((CurrentRetries > 0) && bAutoReQueueWhenSearchCompletesUnsuccessfully) && !Search.bDisableRequeuing)
            {
                AutoRequeue();
            }
            // End:0x331
            else
            {
                MatchmakingReport.UpdateResolution(8);
                // End:0x327
                if(ShouldDisplayWifiError())
                {
                    LaunchNoMatchesOnWifiMessageBox();
                }
                // End:0x331
                else
                {
                    LaunchInvalidSearchMessageBox();
                }
            }
        }
    }
    //return;    
}

function OnSearchGamesCancelled(bool bWasSuccessful)
{
    bCancelledSearching = true;
    MatchmakingReport.UpdateResolution(1);
    CloseGameSearch();
    //return;    
}

function OnTryOnlineGameComplete(name SessionName, bool bWasSuccessful)
{
    Outer.Outer.GameInterface.ClearCreateOnlineGameCompleteDelegate(OnTryOnlineGameComplete);
    Outer.Outer.CloseDialogBox();
    // End:0x170
    if(bWasSuccessful)
    {
        Outer.Outer.PCOwner.SetConnectionError("");
        MatchmakingReport.UpdateResolution(3);
        Outer.Outer.PCOwner.ConsoleCommand("open" @ URL);
    }
    // End:0x1EE
    else
    {
        MatchmakingReport.UpdateResolution(6);
        Outer.Outer.GameInterface.DestroyOnlineGame('Game');
        LaunchFailedCreateMessageBox();
    }
    //return;    
}

function FoxGameSettingsCommon StartCreateOnlineGame(string playlistName, optional string ServerOptions)
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local FoxPRI PRI;
    local int I, PlaylistIndex;
    local array<string> GoodPlaylistNames;
    local FoxGameSettingsCommon GameSettings;
    local DialogBoxProperties Properties;
    local int pos, PlayerLevel, PlayerPrestige;
    local string Password;

    // End:0x24
    if(playlistName != "")
    {
        DesiredPlaylist = playlistName;
    }
    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    PRI = FoxPRI(Outer.Outer.PCOwner.PlayerReplicationInfo);
    PlayerLevel = PRI.CurrentRankIndex;
    PlayerPrestige = PRI.PrestigeLvl;
    // End:0x374
    if(DesiredPlaylist == "")
    {
        GoodPlaylistNames.Length = 0;
        I = 0;
        J0x14A:
        // End:0x354 [Loop If]
        if(I < PlaylistDataStore.PlayListProviders.Length)
        {
            // End:0x346
            if((!PlaylistDataStore.PlayListProviders[I].bCoop && !PlaylistDataStore.PlayListProviders[I].IsConfigFiltered()) && !PlaylistDataStore.PlayListProviders[I].bIsPreventedFromQuickStart)
            {
                // End:0x343
                if((PlaylistDataStore.GetPlaylistSearchFilter() == 0) || PlaylistDataStore.PlayListProviders[I].bIsInSearchFilter)
                {
                    // End:0x340
                    if(PlaylistDataStore.PlaylistEnabledForUserLevel(I, PlayerLevel, PlayerPrestige))
                    {
                        GoodPlaylistNames[GoodPlaylistNames.Length] = string(PlaylistDataStore.PlayListProviders[I].Name);
                        J0x340:
                    }
                    // End:0x340
                    else
                    {
                    }
                    J0x343:
                }
                // End:0x343
                else
                {
                }
                J0x346:
            }
            // End:0x346
            else
            {
            }
            ++ I;
            // [Loop Continue]
            goto J0x14A;
        }
        DesiredPlaylist = GoodPlaylistNames[Rand(GoodPlaylistNames.Length)];
    }
    PlaylistIndex = PlaylistDataStore.GetPlaylistIndexFromPlaylistString(DesiredPlaylist);
    PlaylistDataStore.ResetCycleInfo();
    // End:0x449
    if(!PlaylistDataStore.SelectPlaylistByName(name(DesiredPlaylist)))
    {
        MatchmakingReport.UpdateResolution(7);
        MatchmakingReport.SetNote(DesiredPlaylist);
        LaunchInvalidSearchMessageBox();
        return none;
    }
    Properties.DialogType = 0;
    Properties.TitleText = Localize("Menu", "ConfirmCreateGameTitle", "FoxMenuUI");
    Properties.BodyText = Localize("ServerBrowser", "PrivateMatchCreatingTitle", "FoxMenuUI");
    Properties.bShowTimer = false;
    Properties.OnDialogButtonPressed = None;
    Outer.Outer.ShowDialogBox(Properties);
    URL = ((((((("FoxEntry?Name=" $ Outer.Outer.PlayerInterface.GetPlayerNickname(0)) $ "?listen=true?lanplay=false?Playlist=") $ DesiredPlaylist) $ "?PI=") $ string(PlaylistIndex)) $ "?Game=FoxGame.") $ string(PlaylistDataStore.GetGameClass())) $ ServerOptions;
    GameSettings = FoxGameSettingsCommon(new PlaylistDataStore.static.GetGameClass().default.OnlineGameSettingsClass);
    // End:0x701
    if(GameSettings == none)
    {
        GameSettings = new class'FoxGameSettingsCommon';
    }
    GameSettings.SetToDefaults();
    GameSettings.NumOpenSlots = Clamp(PlaylistDataStore.static.GetGameClass().default.MaxPlayers, 0, PlaylistDataStore.static.GetGameClass().default.MaxPlayersAllowed);
    GameSettings.SetIntProperty(Outer.Outer.268435612, GameSettings.NumOpenSlots);
    GameSettings.SetIntProperty(Outer.Outer.268439552, PlaylistIndex);
    GameSettings.SetIntProperty(Outer.Outer.268439568, PRI.GetRankIndex());
    GameSettings.SetIntProperty(Outer.Outer.268439553, int(PRI.Skill));
    GameSettings.SetStringProperty(Outer.Outer.268435577, DesiredPlaylist);
    // End:0xA89
    if(Outer.Outer.GetWorldInfo().IsConsoleBuild(8))
    {
        GameSettings.SetStringProperty(Outer.Outer.268435608, Outer.Outer.GameInterface.GetGameplayRegionName());
    }
    // End:0xB35
    else
    {
        GameSettings.SetStringProperty(Outer.Outer.268435608, Outer.Outer.PCOwner.DynamicUI.GetCurrentRegionTag());
    }
    GameSettings.SetIntProperty(Outer.Outer.268435717, PlaylistDataStore.GetDifficultyLevel());
    // End:0xE03
    if(InStr(URL, "?PublicGame=1", false, true) != -1)
    {
        GameSettings.SetIntProperty(Outer.Outer.268435576, 1);
        // End:0xE03
        if(PlaylistIndex != -1)
        {
            GameSettings.SetIntProperty(Outer.Outer.268435580, PlaylistDataStore.GetPlaylistMinLevel(PlaylistIndex));
            GameSettings.SetIntProperty(Outer.Outer.268435581, PlaylistDataStore.GetPlaylistMaxLevel(PlaylistIndex));
            GameSettings.SetIntProperty(Outer.Outer.268439572, PlaylistDataStore.GetPlaylistMaxPrestige(PlaylistIndex));
            GameSettings.SetIntProperty(Outer.Outer.268439571, PlaylistDataStore.GetPlaylistMinPrestige(PlaylistIndex));
        }
    }
    pos = InStr(URL, "?GamePassword=", false, true, 0);
    // End:0xF0F
    if(pos != -1)
    {
        Password = Split(URL, "?GamePassword=", true);
        pos = InStr(Password, "?");
        // End:0xEB8
        if(pos != -1)
        {
            Password = Left(Password, pos);
        }
        GameSettings.SetStringProperty(Outer.Outer.1073741830, Password);
    }
    return GameSettings;
    //return ReturnValue;    
}

function ExecuteCreateOnlineGame(FoxGameSettingsCommon InSettings)
{
    Outer.Outer.GameInterface.AddCreateOnlineGameCompleteDelegate(OnTryOnlineGameComplete);
    Outer.Outer.GameInterface.CreateOnlineGame(0, 'Game', InSettings);
    //return;    
}

function TryCreateOnlineGame(optional string playlistName, optional string ServerOptions)
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local FoxPRI PRI;
    local int I, PlaylistIndex;
    local array<string> GoodPlaylistNames;
    local FoxGameSettingsCommon GameSettings;
    local DialogBoxProperties Properties;
    local int pos, PlayerLevel, PlayerPrestige;
    local string Password;

    // End:0x25
    if(playlistName != "")
    {
        DesiredPlaylist = playlistName;
    }
    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    PRI = FoxPRI(Outer.Outer.PCOwner.PlayerReplicationInfo);
    PlayerLevel = PRI.CurrentRankIndex;
    PlayerPrestige = PRI.PrestigeLvl;
    // End:0x375
    if(DesiredPlaylist == "")
    {
        GoodPlaylistNames.Length = 0;
        I = 0;
        J0x14B:
        // End:0x355 [Loop If]
        if(I < PlaylistDataStore.PlayListProviders.Length)
        {
            // End:0x347
            if((!PlaylistDataStore.PlayListProviders[I].bCoop && !PlaylistDataStore.PlayListProviders[I].IsConfigFiltered()) && !PlaylistDataStore.PlayListProviders[I].bIsPreventedFromQuickStart)
            {
                // End:0x344
                if((PlaylistDataStore.GetPlaylistSearchFilter() == 0) || PlaylistDataStore.PlayListProviders[I].bIsInSearchFilter)
                {
                    // End:0x341
                    if(PlaylistDataStore.PlaylistEnabledForUserLevel(I, PlayerLevel, PlayerPrestige))
                    {
                        GoodPlaylistNames[GoodPlaylistNames.Length] = string(PlaylistDataStore.PlayListProviders[I].Name);
                        J0x341:
                    }
                    // End:0x341
                    else
                    {
                    }
                    J0x344:
                }
                // End:0x344
                else
                {
                }
                J0x347:
            }
            // End:0x347
            else
            {
            }
            ++ I;
            // [Loop Continue]
            goto J0x14B;
        }
        DesiredPlaylist = GoodPlaylistNames[Rand(GoodPlaylistNames.Length)];
    }
    PlaylistIndex = PlaylistDataStore.GetPlaylistIndexFromPlaylistString(DesiredPlaylist);
    PlaylistDataStore.ResetCycleInfo();
    // End:0x45F
    if((PlaylistIndex == -1) || !PlaylistDataStore.SelectPlaylistByName(name(DesiredPlaylist)))
    {
        MatchmakingReport.UpdateResolution(7);
        MatchmakingReport.SetNote(DesiredPlaylist);
        LaunchInvalidSearchMessageBox();
        return;
    }
    Properties.DialogType = 0;
    Properties.TitleText = Localize("Menu", "ConfirmCreateGameTitle", "FoxMenuUI");
    Properties.BodyText = Localize("ServerBrowser", "PrivateMatchCreatingTitle", "FoxMenuUI");
    Properties.bShowTimer = false;
    Properties.OnDialogButtonPressed = None;
    Outer.Outer.ShowDialogBox(Properties);
    URL = ((((((("FoxEntry?Name=" $ Outer.Outer.PlayerInterface.GetPlayerNickname(0)) $ "?listen=true?lanplay=false?Playlist=") $ DesiredPlaylist) $ "?PI=") $ string(PlaylistIndex)) $ "?Game=FoxGame.") $ string(PlaylistDataStore.GetGameClass())) $ ServerOptions;
    GameSettings = FoxGameSettingsCommon(new PlaylistDataStore.static.GetGameClass().default.OnlineGameSettingsClass);
    // End:0x717
    if(GameSettings == none)
    {
        GameSettings = new class'FoxGameSettingsCommon';
    }
    GameSettings.SetToDefaults();
    GameSettings.NumOpenSlots = Clamp(PlaylistDataStore.static.GetGameClass().default.MaxPlayers, 0, PlaylistDataStore.static.GetGameClass().default.MaxPlayersAllowed);
    GameSettings.SetIntProperty(Outer.Outer.268435612, GameSettings.NumOpenSlots);
    GameSettings.SetIntProperty(Outer.Outer.268439552, PlaylistIndex);
    GameSettings.SetIntProperty(Outer.Outer.268439568, PRI.GetRankIndex());
    GameSettings.SetIntProperty(Outer.Outer.268439553, int(PRI.Skill));
    GameSettings.SetStringProperty(Outer.Outer.268435577, DesiredPlaylist);
    GameSettings.SetIntProperty(Outer.Outer.268435717, PlaylistDataStore.GetDifficultyLevel());
    // End:0xC83
    if(InStr(URL, "?PublicGame=1", false, true) != -1)
    {
        GameSettings.SetIntProperty(Outer.Outer.268435576, 1);
        // End:0xC83
        if(PlaylistIndex != -1)
        {
            GameSettings.SetIntProperty(Outer.Outer.268435580, PlaylistDataStore.GetPlaylistMinLevel(PlaylistIndex));
            GameSettings.SetIntProperty(Outer.Outer.268435581, PlaylistDataStore.GetPlaylistMaxLevel(PlaylistIndex));
            GameSettings.SetIntProperty(Outer.Outer.268439572, PlaylistDataStore.GetPlaylistMaxPrestige(PlaylistIndex));
            GameSettings.SetIntProperty(Outer.Outer.268439571, PlaylistDataStore.GetPlaylistMinPrestige(PlaylistIndex));
        }
    }
    pos = InStr(URL, "?GamePassword=", false, true, 0);
    // End:0xD8F
    if(pos != -1)
    {
        Password = Split(URL, "?GamePassword=", true);
        pos = InStr(Password, "?");
        // End:0xD38
        if(pos != -1)
        {
            Password = Left(Password, pos);
        }
        GameSettings.SetStringProperty(Outer.Outer.1073741830, Password);
    }
    Outer.Outer.GameInterface.AddCreateOnlineGameCompleteDelegate(OnTryOnlineGameComplete);
    Outer.Outer.GameInterface.CreateOnlineGame(0, 'Game', GameSettings);
    //return;    
}

function OnDestroyForGameFailComplete(name SessionName, bool bWasSuccessful)
{
    Outer.Outer.GameInterface.ClearDestroyOnlineGameCompleteDelegate(OnDestroyForGameFailComplete);
    MatchmakingReport.IncrementJoinFailures();
    // End:0xD1
    if(bAutoJoinGame)
    {
        Outer.Outer.SetTimer(0.010, TryJoinBestGame);
    }
    //return;    
}

function LaunchSearchMessageBox()
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local int Index;

    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    // End:0x2EC
    if(Outer.MatchQueueWidget == none)
    {
        Outer.MatchQueueWidget = Outer.CreateMatchInfoWidget(Localize("Menu", "MatchmakingWidgetLabel", "FoxMenuUI"));
        Outer.MatchQueueWidget.Outer.Advance(0.0);
        // End:0x1FA
        if(class'WorldInfo'.static.IsConsoleBuild())
        {
            Outer.MatchQueueWidget.AddCancelButton(Outer.Outer.GetLocalizedString("Menu", "OnQuickMatchCancel_X"), "", "ei_OnCancelGameSearch");
        }
        // End:0x295
        else
        {
            Outer.MatchQueueWidget.AddCancelButton(Outer.Outer.GetLocalizedString("Menu", "OnQuickMatchCancel"), "", "ei_OnCancelGameSearch");
        }
        Outer.MatchQueueWidget.as_showTimer(true);
        SetProgressText("quickmatchsearchdesc");
    }
    Search.GetIntProperty(Outer.Outer.268439552, Index);
    // End:0x4D0
    if(Index == -1)
    {
        Outer.MatchQueueWidget.UpdateTime(Localize("Menu", "MatchmakingQuickMatchDisc", "FoxMenuUI"));
        // End:0x4CD
        if(class'WorldInfo'.static.IsConsoleBuild())
        {
            Outer.MatchQueueWidget.SetString("playlistText", ((Outer.Outer.GetLocalizedString("Menu", "Matchmakingquickenabledplaylists") @ string(PlaylistDataStore.GetNumEnabledPlaylists())) $ "/") $ string(PlaylistDataStore.GetNumPlaylists()));
        }
    }
    // End:0x541
    else
    {
        Outer.MatchQueueWidget.UpdateTime(PlaylistDataStore.PlayListProviders[Index].FriendlyName);
    }
    Outer.MatchQueueWidget.Outer.Advance(0.0);
    //return;    
}

function OnQuickMatchCancel(optional string Arg)
{
    local DialogBoxProperties Properties;

    bCancelledSearching = true;
    // End:0x1F4
    if(Outer.Outer.GameInterface.IsJoinOperationInProgress())
    {
        Properties.DialogType = 0;
        Properties.TitleText = Localize("Menu", "QuickMatchSeartchTitle", "FoxMenuUI");
        Properties.BodyText = Localize("Menu", "QuickMatchSearchCancelDesc", "FoxMenuUI");
        Properties.bShowTimer = true;
        Properties.OnDialogButtonPressed = None;
        Outer.Outer.ShowDialogBox(Properties);
        Outer.Outer.SetTimer(0.50, OnCancelJoiningMatches);
    }
    // End:0x2AA
    else
    {
        Outer.DestroyMatchInfoWidget();
        // End:0x280
        if(!Search.bIsSearchInProgress)
        {
            Outer.Outer.PCOwner.OnCancelGameJoin();
        }
        MatchmakingReport.UpdateResolution(1);
        CloseGameSearch();
    }
    //return;    
}

function OnCancelJoiningMatches()
{
    // End:0x11E
    if(!Outer.Outer.GameInterface.IsJoinOperationInProgress())
    {
        Outer.Outer.CloseDialogBox();
        // End:0xF0
        if(!Search.bIsSearchInProgress)
        {
            Outer.Outer.PCOwner.OnCancelGameJoin();
        }
        MatchmakingReport.UpdateResolution(2);
        CloseGameSearch();
    }
    // End:0x168
    else
    {
        Outer.Outer.SetTimer(0.50, OnCancelJoiningMatches);
    }
    //return;    
}

function NullOurReference()
{
    Outer.GameSearchQuickOnline = none;
    //return;    
}

function LaunchInvalidSearchMessageBox()
{
    local DialogBoxProperties Properties;

    Outer.DestroyMatchInfoWidget();
    Outer.Outer.CloseDialogBox();
    Properties.DialogType = 1;
    Properties.TitleText = Outer.Outer.GetErrorMessage("QuickMatchNotFoundLabel");
    Properties.BodyText = Outer.Outer.GetErrorMessage("QuickMatchNotFoundDesc");
    Properties.bCloseOnButtonPress = true;
    Outer.Outer.ShowDialogBox(Properties);
    CloseGameSearch();
    //return;    
}

function LaunchNoMatchesOnWifiMessageBox()
{
    local DialogBoxProperties Properties;

    Outer.DestroyMatchInfoWidget();
    Outer.Outer.CloseDialogBox();
    Properties.DialogType = 1;
    Properties.TitleText = Outer.Outer.GetErrorMessage("QuickMatchOnWifiFailureLabel");
    Properties.BodyText = Outer.Outer.GetErrorMessage("QuickMatchOnWifiFailureDesc");
    Properties.bCloseOnButtonPress = true;
    Outer.Outer.ShowDialogBox(Properties);
    CloseGameSearch();
    //return;    
}

function LaunchFailedCreateMessageBox()
{
    local DialogBoxProperties Properties;

    Outer.DestroyMatchInfoWidget();
    Outer.Outer.CloseDialogBox();
    Properties.DialogType = 1;
    Properties.TitleText = Outer.Outer.GetErrorMessage("QuickMatchCreateFailureLabel");
    Properties.BodyText = Outer.Outer.GetErrorMessage("QuickMatchCreateFailureDesc");
    Properties.bCloseOnButtonPress = true;
    Outer.Outer.ShowDialogBox(Properties);
    CloseGameSearch();
    //return;    
}

function OnOnlinePlatformOOM()
{
    local DialogBoxProperties Properties;

    Outer.Outer.GameInterface.ClearOnOnlinePlatformOOMDelegate(OnOnlinePlatformOOM);
    // End:0x21A
    if(class'WorldInfo'.static.IsConsoleBuild(8))
    {
        Outer.DestroyMatchInfoWidget();
        Outer.Outer.CloseDialogBox();
        Properties.DialogType = 1;
        Properties.TitleText = Outer.Outer.GetErrorMessage("ranksearchfailed_title");
        Properties.BodyText = Localize("Errors", "SonySignalMemoryLow", "Engine");
        Properties.bCloseOnButtonPress = true;
        Outer.Outer.ShowDialogBox(Properties);
        bFatalSearchErrorOccured = true;
        CloseGameSearch();
    }
    //return;    
}

function LaunchPartyMembersOverLimitMessageBox(int MaxNumPartyMembers)
{
    local DialogBoxProperties Properties;

    Outer.DestroyMatchInfoWidget();
    Outer.Outer.CloseDialogBox();
    Properties.DialogType = 1;
    Properties.TitleText = Outer.Outer.GetErrorMessage("PartyOverLimit_Title");
    Properties.BodyText = Outer.Outer.GetErrorMessage("PartyOverLimit_Msg_A");
    Properties.BodyText @= string(MaxNumPartyMembers);
    Properties.BodyText @= Outer.Outer.GetErrorMessage("PartyOverLimit_Msg_B");
    Properties.bCloseOnButtonPress = true;
    Outer.Outer.ShowDialogBox(Properties);
    //return;    
}

protected function TryJoinBestGame()
{
    JoinBestGame();
    //return;    
}

private final function JoinBestGame()
{
    local int BestGameIndexToJoin;
    local bool bIsAllowedToHost;
    local string DialogStr;

    // End:0x0F
    if(bCancelledSearching)
    {
        return;
    }
    BestGameIndexToJoin = Outer.Outer.GameSearchDataStore.GetBestGameFromSearch(Search);
    // End:0x298
    if(BestGameIndexToJoin >= 0)
    {
        MatchmakingReport.IncrementJoinAttempts();
        MatchmakingReport.SetJoiningMatchStats(Search.Results[BestGameIndexToJoin].GameSettings.PingInMs, Search.Results[BestGameIndexToJoin].GameSettings.NumOpenSlots, Search.Results[BestGameIndexToJoin].GameSettings.MatchQuality);
        MatchmakingReport.SetResolution(4);
        // End:0x203
        if(bJoiningDedicatedServers)
        {
            DialogStr = "MatchmakingQuickDisplayServers";
        }
        // End:0x22B
        else
        {
            DialogStr = "MatchmakingQuickDisplayGames";
        }
        SetProgressText(DialogStr, BestGameIndexToJoin + 1, Search.Results.Length);
        // End:0x295
        if(!ProcessJoinSelection(BestGameIndexToJoin, bSpectator))
        {
            TryJoinBestGame();
        }
    }
    // End:0x47D
    else
    {
        // End:0x473
        if(!bJoiningDedicatedServers)
        {
            bIsAllowedToHost = Outer.Outer.GameInterface.IsAllowedToNetworkHost();
            MatchmakingReport.SetHostable(bIsAllowedToHost);
            // End:0x3DA
            if((bAutoCreateGame && bIsAllowedToHost) && ((Rand(CreateAnywayOdds) == 0) || CurrentRetries <= 0) || Search.bDisableRequeuing)
            {
                SetProgressText("matchmakingwidgetcreatingagame");
                TryCreateOnlineGame(DesiredPlaylist, "?PublicGame=1");
            }
            // End:0x470
            else
            {
                // End:0x42B
                if(((CurrentRetries > 0) && bAutoReQueueWhenSearchCompletesUnsuccessfully) && !Search.bDisableRequeuing)
                {
                    AutoRequeue();
                }
                // End:0x470
                else
                {
                    MatchmakingReport.UpdateResolution(8);
                    // End:0x466
                    if(ShouldDisplayWifiError())
                    {
                        LaunchNoMatchesOnWifiMessageBox();
                    }
                    // End:0x470
                    else
                    {
                        LaunchInvalidSearchMessageBox();
                    }
                }
            }
        }
        // End:0x47D
        else
        {
            RestartSearchForNativeGames();
        }
    }
    //return;    
}

function CloseGameSearch()
{
    ReportMatchmakingSummery();
    ClearDelegates();
    Outer.DestroyMatchInfoWidget();
    Outer.Outer.PCOwner.DynamicUI.Menu.ToggleInstantGameModeButtons(true);
    super.CloseGameSearch();
    //return;    
}

function ReportMatchmakingSummery()
{
    local string Log;

    // End:0x1B
    if(MatchmakingReport == none)
    {
        ScriptTrace();
        return;
    }
    MatchmakingReport.SetSearchEndTime(Outer.Outer.PCOwner.WorldInfo.RealTimeSeconds);
    Log = MatchmakingReport.PrintLog();
    // End:0x126
    if(Log != "")
    {
        class'GameEngine'.static.GetOnlineSubsystem().StoreInterface.LogClientEvent(5, Log);
    }
    MatchmakingReport = none;
    //return;    
}

function AutoRequeue()
{
    // End:0x9A
    if(Outer.Outer.GameInterface.IsJoinOperationInProgress())
    {
        Outer.Outer.SetTimer(0.50, AutoRequeue);
    }
    // End:0xB9
    else
    {
        -- CurrentRetries;
        BeginOnlineSearch(DesiredPlaylist);
    }
    //return;    
}

function CheckMatchQueue()
{
    Outer.Outer.OnlineSub.GameInterfaceEx.CheckMatchQueue("Public");
    Outer.Outer.SetTimer(5.0, CheckMatchQueue);
    //return;    
}

function StopCheckQueue()
{
    Outer.Outer.ClearTimer(CheckMatchQueue);
    //return;    
}

function Cleanup()
{
    bCancelledSearching = true;
    // End:0x78
    if(Search.bIsSearchInProgress)
    {
        Outer.Outer.GameInterface.CancelFindOnlineGames();
    }
    // End:0x10E
    if(Outer.Outer.GameInterface.IsJoinOperationInProgress())
    {
        Outer.Outer.PCOwner.OnCancelGameJoin();
    }
    Outer.Outer.ClearTimer(CheckMatchQueue);
    CloseGameSearch();
    //return;    
}

function ClearDelegates()
{
    super.ClearDelegates();
    Outer.Outer.GameInterface.ClearFindOnlineGamesCompleteDelegate(OnSearchGamesComplete);
    Outer.Outer.GameInterface.ClearDedicatedServerSearchCompleteDelegate(OnDedicatedServerSearchComplete);
    Outer.Outer.GameInterface.ClearCancelFindOnlineGamesCompleteDelegate(OnSearchGamesCancelled);
    Outer.Outer.GameInterface.ClearCreateOnlineGameCompleteDelegate(OnTryOnlineGameComplete);
    Outer.Outer.GameInterface.ClearOnSearchProgressUpdatedDelegate(OnSearchProgressUpdated);
    Outer.Outer.GameInterface.ClearOnOnlinePlatformOOMDelegate(OnOnlinePlatformOOM);
    Outer.Outer.GameInterfaceEx.ClearOnLeaveMatchQueueDelegate(OnMatchQueueLeave);
    Outer.Outer.GameInterfaceEx.ClearCheckMatchQueueDelegate(OnMatchQueueCheck);
    //return;    
}

function LazyCancelTimer()
{
    bCancelTimerSet = false;
    CancelAndCleanup();
    //return;    
}

event CancelAndCleanup()
{
    bCancelledSearching = true;
    // End:0x173
    if((!bFatalSearchErrorOccured && Search.bSearchAwaitingPing) && Outer.Outer.GetWorldInfo().IsConsoleBuild(8))
    {
        SetProgressText("cancelsearchwidgetdesc");
        bLockCancelProgressText = true;
        Outer.Outer.GameInterface.CancelFindOnlineGames();
        // End:0x170
        if(bCancelTimerSet == false)
        {
            bCancelTimerSet = true;
            Outer.Outer.SetTimer(5.0, LazyCancelTimer);
        }
    }
    // End:0x1AA
    else
    {
        bCancelTimerSet = false;
        MatchmakingReport.UpdateResolution(9);
        Cleanup();
    }
    //return;    
}

function bool ShouldDisplayWifiError()
{
    // End:0xE8
    if(class'WorldInfo'.static.IsConsoleBuild(8) && Outer.Outer.GameInterface.IsFilteringWifi())
    {
        return Outer.Outer.PCOwner.OnlineSub.SystemInterface.IsWifiConnection();
    }
    return false;
    //return ReturnValue;    
}

function OnSearchProgressUpdated(string ProgressText, optional int OptionalNumerator, optional int OptionalDenominator)
{
    OptionalNumerator = -1;
    OptionalDenominator = -1;
    SetProgressText(ProgressText, OptionalNumerator, OptionalDenominator);
    //return;    
}

function SetProgressText(string LocName, optional int OptionalNumerator, optional int OptionalDenominator)
{
    local string ProgressText;

    OptionalNumerator = -1;
    OptionalDenominator = -1;
    ProgressText = Localize("Menu", LocName, "FoxMenuUI");
    // End:0x11D
    if((Outer.MatchQueueWidget != none) && !bLockCancelProgressText)
    {
        // End:0xE0
        if(OptionalNumerator != -1)
        {
            ProgressText @= string(OptionalNumerator);
            // End:0xE0
            if(OptionalDenominator != -1)
            {
                ProgressText $= ("/" $ string(OptionalDenominator));
            }
        }
        Outer.MatchQueueWidget.UpdateQueue(ProgressText);
    }
    //return;    
}

defaultproperties
{
    bAutoCreateGame=true
    bAutoReQueueWhenSearchCompletesUnsuccessfully=true
    bShouldInvalidateGameSearchResults=true
    TimeSearchTimeout=5.0
    MaxRetriesBeforeGameCreate=7
    CreateAnywayOdds=5
    QuickOnslaughtPlaylist="OS_Medium"
    bCreatesGameIfNoneFound=true
    bCloseOnError=true
}